import structure5.*;
import java.util.Iterator;

/**
   Testing class for Iterator examples

   @version $Id: Iterators.java 950 2009-10-07 02:09:52Z terescoj $
   @author Jim Teresco, 2009
*/

public class Iterators {

    public static final int SIZE = 10;

    public static void main(String args[]) {

	// create a vector of integers for testing
	Vector<Integer> v = new Vector<Integer>(SIZE);
	for (int i=0; i<SIZE; i++) {
	    v.add(i);
	}

	// traverse with the standard iterator
	System.out.println("Standard iterator:");
	Iterator<Integer> vi = v.iterator();
	while (vi.hasNext()) {
	    System.out.println(vi.next());
	}

	// traverse with even-only iterator
	System.out.println("Even-only iterator:");
	vi = new VectorEvenIterator<Integer>(v);
	while (vi.hasNext()) {
	    System.out.println(vi.next());
	}

	// traverse with prefix sum iterator
	System.out.println("Prefix sum iterator:");
	vi = new PrefixSumIterator(v);
	while (vi.hasNext()) {
	    System.out.println(vi.next());
	}

    }
}
